<template>
  <div>
    <a id="menu-share" class="float">
      <svg viewBox="0 0 52 52">
        <path
          fill="none"
          d="M26,0C11.664,0,0,11.663,0,26s11.664,26,26,26s26-11.663,26-26S40.336,0,26,0z M26,50C12.767,50,2,39.233,2,26
		        S12.767,2,26,2s24,10.767,24,24S39.233,50,26,50z"
        />
        <path
          fill="currentColor"
          d="M38.5,25H27V14c0-0.553-0.448-1-1-1s-1,0.447-1,1v11H13.5c-0.552,0-1,0.447-1,1s0.448,1,1,1H25v12c0,0.553,0.448,1,1,1
		        s1-0.447,1-1V27h11.5c0.552,0,1-0.447,1-1S39.052,25,38.5,25z"
        />
      </svg>
    </a>
    <ul class="popup-menu">
      <!-- Form -->
      <li class="popup-menu-item">
        <a @click="showModal">
          <svg class="form" viewBox="0 0 512 512" height="35" width="35">
            <path
              fill="currentColor"
              class="icon-primary"
              d="M397.736,78.378c6.824,0,12.358-5.533,12.358-12.358V27.027C410.094,12.125,397.977,0,383.08,0H121.641
                c-3.277,0-6.42,1.303-8.739,3.62L10.527,105.995c-2.317,2.317-3.62,5.461-3.62,8.738v370.239C6.908,499.875,19.032,512,33.935,512
                h349.144c14.897,0,27.014-12.125,27.014-27.027V296.289c0.001-6.824-5.532-12.358-12.357-12.358
                c-6.824,0-12.358,5.533-12.358,12.358v188.684c0,1.274-1.031,2.311-2.297,2.311H33.936c-1.274,0-2.311-1.037-2.311-2.311v-357.88
                h75.36c14.898,0,27.016-12.12,27.016-27.017V24.716H383.08c1.267,0,2.297,1.037,2.297,2.311V66.02
                C385.377,72.845,390.911,78.378,397.736,78.378z M109.285,100.075c0,1.269-1.032,2.301-2.3,2.301H49.107l60.178-60.18V100.075z"
            />
            <path
              fill="currentColor"
              class="icon-secondary"
              d="M492.865,100.396l-14.541-14.539c-16.304-16.304-42.832-16.302-59.138,0L303.763,201.28H103.559
                c-6.825,0-12.358,5.533-12.358,12.358c0,6.825,5.533,12.358,12.358,12.358h175.488l-74.379,74.379H103.559
                c-6.825,0-12.358,5.533-12.358,12.358s5.533,12.358,12.358,12.358h76.392l-0.199,0.199c-1.508,1.508-2.598,3.379-3.169,5.433
                l-19.088,68.747h-53.936c-6.825,0-12.358,5.533-12.358,12.358s5.533,12.358,12.358,12.358h63.332c0.001,0,2.709-0.306,3.107-0.41
                c0.065-0.017,77.997-21.642,77.997-21.642c2.054-0.57,3.926-1.662,5.433-3.169l239.438-239.435
                C509.168,143.228,509.168,116.7,492.865,100.396z M184.644,394.073l10.087-36.326l26.24,26.24L184.644,394.073z M244.69,372.752
                l-38.721-38.721l197.648-197.648l38.722,38.721L244.69,372.752z M475.387,142.054l-15.571,15.571l-38.722-38.722l15.571-15.571
                c6.669-6.668,17.517-6.667,24.181,0l14.541,14.541C482.054,124.54,482.054,135.388,475.387,142.054z"
            />
          </svg>
        </a>
      </li>
      <!-- String -->
      <li class="popup-menu-item">
        <a @click="showModalLinestring">
          <svg class="linestring" viewBox="0 0 512 512" height="40" width="40">
            <path
              fill="currentColor"
              class="icon-primary"
              d="M457.637,134.681c-29.976,0-54.363,24.387-54.363,54.363c0,10.933,3.255,21.114,8.831,29.647l-58.733,58.733
                c-8.534-5.576-18.715-8.831-29.648-8.831c-11.329,0-21.858,3.488-30.576,9.441l-59.338-59.347
                c5.575-8.533,8.828-18.713,8.828-29.644c0-29.976-24.387-54.363-54.363-54.363c-29.976,0-54.363,24.387-54.363,54.363
                c0,10.931,3.254,21.108,8.827,29.641L84.004,277.42c-8.532-5.574-18.711-8.827-29.641-8.827C24.387,268.593,0,292.981,0,322.957
                s24.387,54.363,54.363,54.363c29.976,0,54.363-24.387,54.363-54.363c0-10.933-3.255-21.114-8.831-29.648l58.733-58.733
                c8.534,5.576,18.715,8.831,29.648,8.831c10.932,0,21.113-3.255,29.646-8.831l59.666,59.674
                c-5.206,8.338-8.226,18.174-8.226,28.706c0,29.976,24.387,54.363,54.363,54.363s54.363-24.387,54.363-54.363
                c0-10.931-3.254-21.109-8.827-29.641l58.736-58.736c8.533,5.574,18.712,8.827,29.641,8.827c29.976,0,54.363-24.387,54.363-54.363
                C512.001,159.066,487.613,134.681,457.637,134.681z M54.363,354.849c-17.586,0-31.893-14.307-31.893-31.892
                c0-17.586,14.307-31.893,31.893-31.893c17.585,0,31.893,14.307,31.893,31.893C86.256,340.542,71.949,354.849,54.363,354.849z
                M188.276,220.936c-17.585,0-31.893-14.307-31.893-31.893c0-17.585,14.307-31.893,31.893-31.893
                c17.586,0,31.893,14.307,31.893,31.893C220.169,206.629,205.862,220.936,188.276,220.936z M323.724,354.849
                c-17.585,0-31.893-14.307-31.893-31.893s14.307-31.893,31.893-31.893c17.585,0,31.893,14.307,31.893,31.893
                C355.616,340.542,341.309,354.849,323.724,354.849z M457.637,220.936c-17.585,0-31.893-14.307-31.893-31.893
                c0-17.585,14.307-31.893,31.893-31.893c17.585,0,31.893,14.307,31.893,31.893C489.53,206.629,475.222,220.936,457.637,220.936z"
            />
            <path
              fill="currentColor"
              class="icon-secondary"
              d="M176.774,272.717c-4.388-4.387-11.501-4.387-15.889,0l-22.854,22.854c-4.387,4.387-4.387,11.501,0.001,15.889
			          c2.194,2.194,5.069,3.291,7.944,3.291s5.751-1.098,7.944-3.291l22.854-22.854C181.163,284.219,181.163,277.104,176.774,272.717z"
            />
            <path
              fill="currentColor"
              class="icon-secondary"
              d="M373.962,200.939c-4.388-4.387-11.5-4.387-15.89,0.001l-22.854,22.854c-4.387,4.387-4.387,11.501,0,15.889
                c2.195,2.193,5.07,3.29,7.945,3.29c2.876,0,5.75-1.098,7.944-3.291l22.854-22.854C378.349,212.44,378.349,205.326,373.962,200.939
                z"
            />
          </svg>
        </a>
      </li>
    </ul>
    <form-create-offer
      class="form-create-offer"
      v-if="showCreateOffer"
      @changeStatus="updateStatus($event)"
    ></form-create-offer>
    <form-create-offer-linestring
      class="form-create-offer"
      v-if="showCreateOfferLinestring"
      @changeStatus="updateStatus($event)"
    ></form-create-offer-linestring>
  </div>
</template>

<script>
import FormCreateOffer from '@/components/FormCreateOffer'
import FormCreateOfferLinestring from '@/components/FormCreateOfferLinestring'
export default {
  name: 'AddOfferButton',
  components: {
    FormCreateOffer,
    FormCreateOfferLinestring
  },
  data() {
    return {
      showCreateOffer: false,
      showCreateOfferLinestring: false
    }
  },
  methods: {
    showModal() {
      this.showCreateOffer = true
    },
    showModalLinestring() {
      this.showCreateOfferLinestring = true
    },
    closeModal() {
      this.showCreateOffer = false
    },
    updateStatus(updatedStatus) {
      this.showCreateOffer = updatedStatus
      this.showCreateOfferLinestring = updatedStatus
      this.$emit('reloadData')
    }
  }
}
</script>

<style scoped>
.float {
  position: fixed;
  width: 4rem;
  height: 4rem;
  bottom: 5rem;
  right: 5rem;
  border: var(--border);
  background-color: var(--bg-primary);
  color: var(--text-primary);
  border-radius: 50px;
  text-align: center;
  box-shadow: var(--drop-shadow);
  z-index: 1;
  cursor: pointer;
}

ul {
  position: fixed;
  right: 5rem;
  padding-bottom: 10px;
  bottom: calc(6rem + 40px);
  z-index: 100;
}

ul li {
  list-style: none;
  margin-bottom: 10px;
}

ul li a {
  background-color: var(--bg-primary);
  color: var(--text-primary);
  text-align: center;
  box-shadow: var(--drop-shadow);
  width: 4rem;
  height: 4rem;
  display: block;
  cursor: pointer;
  border-radius: 50px;
  border: var(--border);
}

ul li a svg {
  height: 3rem;
}

.popup-menu-item {
  filter: grayscale(100%) opacity(0.7);
}

.popup-menu-item:hover {
  filter: grayscale(0%) opacity(1);
  color: var(--text-secondary);
}

ul:hover {
  visibility: visible !important;
  opacity: 1 !important;
}

.my-float {
  font-size: 24px;
  margin-top: 18px;
}

.icon-primary {
  color: var(--accent-light);
}

.icon-secondary {
  color: var(--accent-dark);
}

.float:hover {
  background-color: var(--bg-secondary);
  color: var(--accent-light);
}

.form-create-offer {
  z-index: 10;
}

a#menu-share + ul {
  visibility: hidden;
}

a#menu-share:hover + ul {
  visibility: visible;
  animation: scale-in var(--transition-speed);
}

.point,
.linestring,
.form {
  padding-top: 0.75rem;
}

@keyframes scale-in {
  from {
    transform: scale(0);
    opacity: 0;
  }
  to {
    transform: scale(1);
    opacity: 1;
  }
}

@media only screen and (max-width: 813px) {
  .float {
    right: 4rem;
    bottom: 7rem;
    animation: none;
  }
  ul {
    right: 4rem;
    bottom: calc(7rem + 40px);
  }
}
</style>
